From a1f763a15abc041815da97b79bab8d56513a6741 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=A7=9C=E6=B5=B7=E5=A4=A9?= <1076168468@qq.com>
Date: Wed, 2 Nov 2022 17:36:40 +0800
Subject: [PATCH] =?UTF-8?q?=E4=BB=BB=E5=8A=A1=E5=AE=8C=E6=88=90=EF=BC=8C?=
 =?UTF-8?q?=E6=8F=90=E4=BA=A4=E4=BD=9C=E4=B8=9A?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 block.c | 65 ++++++++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 46 insertions(+), 19 deletions(-)

diff --git a/block.c b/block.c
index 4102969..c544041 100644
--- a/block.c
+++ b/block.c
@@ -379,14 +379,6 @@ RETURN:
 //
 ULONG SubQueueRemainLength = SUB_QUEUE_LENGTH;
 
-//
-// ɨ㷨дͷƶķ򡣲ϵͳʱʼΪͷƶ
-// TRUEͷƶŵӡ
-// FALSEͷƶŵż١
-//
-BOOL ScanInside = TRUE;
-
-
 PREQUEST
 IopDiskSchedule(
 	VOID
@@ -414,18 +406,53 @@ IopDiskSchedule(
 --*/
 {
 	PLIST_ENTRY pListEntry;
-	PREQUEST pNextRequest;
+	PREQUEST pRequest;
+	LONG Offset;
 	
-	//
-	// FCFS (First-Come,First-Served) ̵㷨һ򵥵Ĵ̵㷨
-	// ѡеĵһ󣬴Ӷ̷߳ʴ̵Ⱥ˳еȡ
-	//
-	pListEntry = RequestListHead.Next;	// еĵһͷָһ
+	ULONG InsideShortestDistance = 0xFFFFFFFF;
+	ULONG OutsideLongestDistance = 0;
+	PREQUEST pNextInsideRequest = NULL;
+	PREQUEST pNextOutsideRequest = NULL;
 	
-	//
-	// ָ
-	//
-	pNextRequest = CONTAINING_RECORD(pListEntry, REQUEST, ListEntry);
+	for (pListEntry = RequestListHead.Next;	// еĵһͷָһ
+	     pListEntry != &RequestListHead;	// ͷʱѭ
+	     pListEntry = pListEntry->Next) {
+	
+		//
+		// ָ
+		//
+		pRequest = CONTAINING_RECORD(pListEntry, REQUEST, ListEntry);
+		
+		//
+		// Ӧ߳ʵĴŵ뵱ǰͷڴŵƫƣʾ
+		//
+		Offset = pRequest->Cylinder - CurrentCylinder;
+		
+		if (0 == Offset) {
+			//
+			// ߳ҪʵĴŵ뵱ǰͷڴŵͬء
+			//
+			return pRequest;
+		} else if (Offset > 0) {
+			//
+			// ¼ƶ̵߳
+			//
+			if (Offset < InsideShortestDistance) {
+		
+				InsideShortestDistance = Offset;
+				pNextInsideRequest = pRequest;
+			}
+		} else if (Offset < 0) {
+			//
+			// ¼ƶ߳
+			//
+			if (-Offset > OutsideLongestDistance) {
+		
+				OutsideLongestDistance = -Offset;
+				pNextOutsideRequest = pRequest;
+			}
+		}
+	}
 	
-	return pNextRequest;
+	return pNextInsideRequest ? pNextInsideRequest : pNextOutsideRequest;
 }
-- 
2.34.1.windows.1

